-- Copyright © 2008 - 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.

if select(2,UnitClass("player")) ~= XiTimersClass then return end

local nrfonts = 0

local L = LibStub("AceLocale-3.0"):GetLocale(XiTimersGUILocale, true)

local LSM = LibStub:GetLibrary("LibSharedMedia-3.0", true)

local LibDialog = LibStub:GetLibrary("LibDialog-1.0")


XiTimers.options = {
    type = "group",
    args = {
        general = {
            type = "group",
            name = "general",
            args = {
                version= {
                    order = 0,
                    type ="description",
                    name = L["Version"]..": "..tostring(GetAddOnMetadata("XiTimers", "Version"))
                },
				unlockspells = {
				    order = 1,
                    type = "execute",
                    name = L["Unlock Spells"],
                    desc = L["Unlocks the button grid to change the spells on the timer buttons"],
                    func = function(info, val) XiTimers.ShowGrid() LibDialog:Spawn("XiTimers_Spells") InterfaceOptionsFrame:Hide() end,			
                    get = function(info) return XiTimers.ActiveProfile.UnlockSpells end,
				},
                unlock = {
                    order = 2,
                    type = "execute",
                    name = L["Unlock Bars"],
                    desc = L["Unlocks the position of Bars and Frames"],
                    func = function(info, val) XiTimers.UnlockBars() LibDialog:Spawn("XiTimers_Bars") InterfaceOptionsFrame:Hide() end,
                },   
                flashred = {
                    order = 3,
                    type = "toggle",
                    name = L["Red Flash Color"],
                    desc = L["RedFlash Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.FlashRed = val XiTimers.ProcessSetting("FlashRed") end,
                    get = function(info) return XiTimers.ActiveProfile.FlashRed end,
                }, 
                stoppulse = {
                    order = 4,
                    type = "toggle",
                    name = L["Stop Pulse"],
                    desc = L["Stop Pulse Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.StopPulse = val XiTimers.ProcessSetting("StopPulse") end,
                    get = function(info) return XiTimers.ActiveProfile.StopPulse end,
                },
                showTimerBars = {
                    order = 5,
                    type = "toggle",
                    name = L["Show Timer Bars"],
                    desc = L["Displays timer bars underneath times"],
                    set = function(info, val) XiTimers.ActiveProfile.ShowTimerBars = val XiTimers.ProcessSetting("ShowTimerBars") end,
                    get = function(info) return XiTimers.ActiveProfile.ShowTimerBars end,
                },
                timersonbuttons = {
                    order = 6,
                    type = "toggle",
                    name = L["Timers On Buttons"],
                    desc = L["Timers On Buttons Desc"],
                    set = function(info, val) 
                        XiTimers.ActiveProfile.TimersOnButtons = val 
                        XiTimers.ProcessSetting("TimersOnButtons")
                        for i=1,#XiTimers.timers do
                            XiTimers.timers[i]:SetTimerBarPos(XiTimers.timers[i].timerBarPos)
                        end
                    end,
                    get = function(info) return XiTimers.ActiveProfile.TimersOnButtons end,
                },
                hideblizztimers = {
                    order = 7,
                    type = "toggle",
                    name = L["Hide Blizzard Timers"],
                    set = function(info, val) XiTimers.ActiveProfile.HideBlizzTimers = val XiTimers.ProcessSetting("HideBlizzTimers") end,
                    get = function(info) return XiTimers.ActiveProfile.HideBlizzTimers end,
                },                  
                hidedefaulttotembar = {
                    order = 8,
                    type = "toggle",
                    name = L["Hide Default Totem Bar"],
                    desc = L["Hide Default Totem Bar Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.HideDefaultTotemBar = val
                            XiTimers.ProcessSetting("HideDefaultTotemBar") end,
                    get = function(info) return XiTimers.ActiveProfile.HideDefaultTotemBar  end,
                },                  
                tooltips = {
                    order = 9,
                    type = "toggle",
                    name = L["Show Tooltips"],
                    desc = L["Shows tooltips on timer and totem buttons"],
                    set = function(info, val) XiTimers.ActiveProfile.Tooltips = val XiTimers.ProcessSetting("Tooltips") end,
                    get = function(info) return XiTimers.ActiveProfile.Tooltips end,
                },  
                tooltipsatbuttons = {
                    order = 10,
                    type = "toggle",
                    name = L["Tooltips At Buttons"],
                    desc = L["Tooltips At Buttons Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.TooltipsAtButtons = val XiTimers.ProcessSetting("TooltipsAtButtons") end,
                    get = function(info) return XiTimers.ActiveProfile.TooltipsAtButtons end,
                },
                HideInVehicle = {
                    order = 11,
                    type = "toggle",
                    name = L["Hide In Vehicles"],
                    desc = L["Hide In Vehicles Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.HideInVehicle = val XiTimers.ProcessSetting("HideInVehicle") end,
                    get = function(info) return XiTimers.ActiveProfile.HideInVehicle end,
                },                
                Keybinds = {
                     order = 12,
                   type = "toggle",
                    name = L["Show Key Bindings"],
                    desc = L["Shows key bindings on totem timers"],
                    set = function(info, val) XiTimers.ActiveProfile.ShowKeybinds = val XiTimers.ProcessSetting("ShowKeybinds") end,
                    get = function(info) return XiTimers.ActiveProfile.ShowKeybinds end,
                },                 
                h1 = {
                    order = 20,
                    type = "header",
                    name = "",
                },
                TimerBarTexture = {
                    order = 35,
                    type = "select",
                    name = L["Timer Bar Texture"],
                    values = AceGUIWidgetLSMlists.statusbar,
                    set = function(info, val) XiTimers.ActiveProfile.TimerBarTexture = val XiTimers.ProcessSetting("TimerBarTexture") end,
                    get = function(info) return XiTimers.ActiveProfile.TimerBarTexture end,
                    dialogControl = "LSM30_Statusbar",
                },                
                TimeFont = {
                    order = 35,
                    type = "select",
                    name = L["Time Font"] ,
                    values = AceGUIWidgetLSMlists.font,
                    set = function(info, val) XiTimers.ActiveProfile.TimeFont = val XiTimers.ProcessSetting("TimeFont") end,
                    get = function(info) return XiTimers.ActiveProfile.TimeFont end,
                    dialogControl = "LSM30_Font",
                }, 
                TimeColor = {
                    order = 36,
                    type = "color",
                    name = L["Time Color"],
                    set = function(info, r,g,b)
                        XiTimers.ActiveProfile.TimeColor.r = r
                        XiTimers.ActiveProfile.TimeColor.g = g
                        XiTimers.ActiveProfile.TimeColor.b = b
                        XiTimers.ProcessSetting("TimeColor")
                    end,
                    get = function(info) return XiTimers.ActiveProfile.TimeColor.r,
                                                XiTimers.ActiveProfile.TimeColor.g,
                                                XiTimers.ActiveProfile.TimeColor.b,
                                                1
                          end,
                },
                TimerBarColor = {
                    order = 37,
                    type = "color",
                    name = L["Timer Bar Color"],
                    hasAlpha = true,
                    set = function(info, r,g,b,a)
                        XiTimers.ActiveProfile.TimerBarColor.r = r
                        XiTimers.ActiveProfile.TimerBarColor.g = g
                        XiTimers.ActiveProfile.TimerBarColor.b = b
                        XiTimers.ActiveProfile.TimerBarColor.a = a
                        XiTimers.ProcessSetting("ColorTimerBars")
                    end,
                    get = function(info) return XiTimers.ActiveProfile.TimerBarColor.r,
                                                XiTimers.ActiveProfile.TimerBarColor.g,
                                                XiTimers.ActiveProfile.TimerBarColor.b,
                                                XiTimers.ActiveProfile.TimerBarColor.a
                          end,
                },
				hm = {
					order = 200,
					type = "header",
					name = "",
				},
				--[[maelstrombar = {
                    order = 201,
                    type = "toggle",
                    name = L["Maelstrom Bar"],
                    desc = L["Maelstrom Bar Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.MaelstromBar = val XiTimers.ProcessSetting("MaelstromBar") end,
                    get = function(info) return XiTimers.ActiveProfile.MaelstromBar end,
                }, 
				manabar = {
                    order = 202,
                    type = "toggle",
                    name = L["Mana Bar"],
                    desc = L["Mana Bar Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.ManaBar = val XiTimers.ProcessSetting("ManaBar") end,
                    get = function(info) return XiTimers.ActiveProfile.ManaBar end,
                }, 
				flameshockbar = {
                    order = 203,
                    type = "toggle",
                    name = L["Flame Shock Duration"],
                    desc = L["Flame Shock Duration Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.FlameshockBar = val XiTimers.ProcessSetting("FlameshockBar") end,
                    get = function(info) return XiTimers.ActiveProfile.FlameshockBar end,
                },
				flameshockbarresto = {
                    order = 204,
                    type = "toggle",
                    name = L["Flame Shock Duration Restoration"],
                    desc = L["Flame Shock Duration Restoration Desc"],
                    set = function(info, val) XiTimers.ActiveProfile.FlameshockBarRestoration = val XiTimers.ProcessSetting("FlameshockBarRestoration") end,
                    get = function(info) return XiTimers.ActiveProfile.FlameshockBarRestoration end,
                }, ]]
          
            },
        },
    },
}


local ACR =	LibStub("AceConfigRegistry-3.0")
ACR:RegisterOptionsTable(XiTimersGUIAddonName, XiTimers.options)
local ACD = LibStub("AceConfigDialog-3.0")
local frame = ACD:AddToBlizOptions(XiTimersGUIAddonName, XiTimersGUIAddonName, nil, "general")
frame:SetScript("OnEvent", function(self) InterfaceOptionsFrame:Hide() end)
frame:HookScript("OnShow", function(self) if InCombatLockdown() then InterfaceOptionsFrame:Hide() end XiTimers.LastGUIPanel = self end)
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
XiTimers.LastGUIPanel = frame




