-- Copyright © 2008 - 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current distribution permissions only include curse.com, wowinterface.com and their respective addon updaters

if select(2,UnitClass("player")) ~= XiTimersClass then return end

local Timers = XiTimers.timers

local LSM = LibStub:GetLibrary("LibSharedMedia-3.0", true)

local SettingsFunctions



function XiTimers.ProcessSetting(setting)
    if SettingsFunctions[setting] then
        SettingsFunctions[setting](XiTimers.ActiveProfile[setting], XiTimers.timers)
    end
end


function XiTimers.ProcessAllSettings()
    for k,v in pairs(XiTimers.ActiveProfile) do
        XiTimers.ProcessSetting(k)
    end
end


SettingsFunctions = {

    ShowTimerBars = 
        function(value, Timers) 
            for _,timer in pairs(Timers) do
				timer.visibleTimerBars = value
				if timer.timer>0 and value and not timer.timerOnButton then
					timer:ShowTimerBar()
				else
					timer.timerBar.background:Hide()
					timer.timerBar:SetValue(0)			
				end
            end
        end,
		

    FlashRed = 
        function(value, Timers)
        	for _,timer in pairs(Timers) do
                timer.flashRed = value
            end
        end,
        
    TimerSize = 
        function(value, Timers)
            local v = value
    		for e=1,#Timers do
    			Timers[e]:SetScale(v/36)
    		end
        end,
        
    TimerTimeHeight =
        function(value, Timers)
    		for e=1,#Timers do
				Timers[e]:SetTimeHeight(value)
				Timers[e].button.time:SetFont(Timers[e].button.time:GetFont(),value+5,"OUTLINE")
			end
        end,
        
       
    TimerSpacing = 
        function(value, Timers)
    		for e=1,#Timers do
    			Timers[e]:SetSpacing(value)
    		end
        end,
        
        
    TimerTimeSpacing = 
        function(value, Timers)
    		for e=1,#Timers do
				Timers[e]:SetTimeSpacing(value)
    		end
        end,
        
    TimerTimePos = 
        function(value, Timers)
    		for e=1,#Timers do
				Timers[e]:SetTimerBarPos(value)
    		end  
        end,
       

		
	ActionBarButtonPosition =
		function(value, Timers)
			for i=1,#XiTimers.actionBars do
				XiTimers.actionBars[i].position = value[i]
			end
		end,
        
    
    ProcFlash =
        function(value, Timers)
            for i=1,#Timers do
                Timers[i].procFlash = value
            end
        end,
     
    TimeFont =
        function(value, Timers)
            local font = LSM:Fetch("font", value)
            if font then
                for _,timer in pairs(Timers) do
                    timer:SetFont(font)
                end
            end
        end,
        
    TimerBarTexture =
        function(value, Timers) 
            local texture = LSM:Fetch("statusbar", value)
            if texture then
                for _,timer in pairs(Timers) do
                    timer:SetBarTexture(texture)
                end
            end
        end,
        
       
    --[[ BarBindings =
        function(value, Timers)
            for i=1,4 do
                for j=1,5 do
                    local key = GetBindingKey("TOTEMTIMERSCAST"..i..j)
                    if TotemTimers.ActiveProfile.BarBindings and not TotemTimers.ActiveProfile.MenusAlwaysVisible then
                        if TotemTimers.ActiveProfile.ReverseBarBindings then
                            getglobal("TT_ActionButton"..i..j.."HotKey"):SetText(key or tostring(10-j))
                            getglobal("TT_ActionButton"..i..j):SetAttribute("binding", tostring(10-j))
                        else
                            getglobal("TT_ActionButton"..i..j.."HotKey"):SetText(key or tostring(j))
                            getglobal("TT_ActionButton"..i..j):SetAttribute("binding", tostring(j))
                        end
                    else
                        getglobal("TT_ActionButton"..i..j.."HotKey"):SetText(key or "")
                        getglobal("TT_ActionButton"..i..j):SetAttribute("binding", nil)
                    end
                end
            end
        end, ]]--
        
    Tooltips =  
        function(value, Timers)
            for i=1,#Timers do
				if value then
					Timers[i].button:SetAttribute("_onenter", [[ control:CallMethod("ShowTooltip")]])
					Timers[i].button:SetAttribute("_onleave", [[ control:CallMethod("HideTooltip")]])
				else
					Timers[i].button.SetAttribute("_onenter", nil)
					Timers[i].button.SetAttribute("_onleave", nil)
				end
            end
        end,
		
	TooltipsAtButtons = 
		function(value, Timers)
			XiTimers.TooltipsAtButtons = value
		end,

        
    --[[ShowKeybinds =
        function(value, Timers)
            for _,t in pairs(Timers) do
                if value then
                    t.button.hotkey:Show()
                else
                    t.button.hotkey:Hide()
                end
            end
        end,]]
        
        
    TimersOnButtons = 
        function(value, Timers)
            for i=1,#Timers do
                Timers[i].timerOnButton = value
                if Timers[i].timer > 0 then Timers[i]:Start(Timers[i].timer, Timers[i].duration) end
            end
       end,
    
    TimeColor = 
        function(value, Timers)
            for i=1,#Timers do
                Timers[i].button.time:SetTextColor(value.r, value.g, value.b, 1)
                Timers[1].timeColor = value
                for j=1,#Timers[i].timerBars do
                    Timers[i].timerBars[j].time:SetTextColor(value.r,value.g,value.b,1)
                end
            end
        end,
        
   
    HideInVehicle = 
        function(value, Timers)
            if value then
                for k,v in pairs(Timers) do
                    RegisterStateDriver(v.button,"invehicle","[bonusbar:5]hide;show")
                end
            else
                for k,v in pairs(Timers) do
                    UnregisterStateDriver(v.button,"invehicle")
                end
            end
        end,
   
    StopPulse =
        function(value, Timers)
            for i = 1,#Timers do
                Timers[i].StopPulse = value
            end
        end,
        
   --[[ HideEnhanceCDsOOC =
        function(value)
			local Timers = TotemTimers.EnhanceCDs
            for i = 1,#Timers do
                Timers[i].HideOOC = value
				Timers[i].button:SetAttribute("HideOOC", value)
            end
            TotemTimers.ConfigEnhanceCDs()
        end,]]
        
        
    --[[EarthShieldTargetName =
        function(value, Timers)
            if value then
                Timers[7].nameframe:Show()
            else
                Timers[7].nameframe:Hide()
            end
        end,]]
        
        
    Clickthrough = 
        function(value, Timers)
            for i = 1,#Timers do
				Timers[i]:Clickthrough(value)
            end
        end,

}

XiTimers.Settings = SettingsFunctions


